jQuery(document).ready(function ($) {
    "use strict";
    let congratulations_effect = _wplwl_get_email_params.congratulations_effect;
    let font_size = _wplwl_get_email_params.font_size;
    let wheel_size = _wplwl_get_email_params.wheel_size;
    let custom_field_name_enable = _wplwl_get_email_params.custom_field_name_enable;
    let custom_field_name_required = _wplwl_get_email_params.custom_field_name_required;
    let custom_field_mobile_enable = _wplwl_get_email_params.custom_field_mobile_enable;
    let custom_field_mobile_required = _wplwl_get_email_params.custom_field_mobile_required;

    let wplwl_hide_popup = _wplwl_get_email_params.hide_popup;
    let color = _wplwl_get_email_params.bg_color;
    let slices_text_color = _wplwl_get_email_params.slices_text_color;
    let label = _wplwl_get_email_params.label;
    let piece_coupons = _wplwl_get_email_params.prize_type;
    let wplwl_auto_close = parseInt(_wplwl_get_email_params.auto_close);
    let wplwl_notify_position = _wplwl_get_email_params.position;
    let wplwl_show_again = _wplwl_get_email_params.show_again;
    let wplwl_show_again_unit = _wplwl_get_email_params.show_again_unit;
    let time_if_close = _wplwl_get_email_params.time_if_close;
    let wplwl_skip_enter_email = _wplwl_get_email_params.wplwl_skip_enter_email;
    switch (wplwl_show_again_unit) {
        case 'm':
            wplwl_show_again *= 60;
            break;
        case 'h':
            wplwl_show_again *= 60 * 60;
            break;
        case 'd':
            wplwl_show_again *= 60 * 60 * 24;
            break;
        default:
    }
    let intent_type = _wplwl_get_email_params.intent;
    let initial_time = _wplwl_get_email_params.show_wheel;
    let scroll_amount = _wplwl_get_email_params.scroll_amount;
    let wplwl_center_color = _wplwl_get_email_params.wheel_center_color;
    let wplwl_border_color = _wplwl_get_email_params.wheel_border_color;
    let wplwl_dot_color = _wplwl_get_email_params.wheel_dot_color;
    let gdpr_checkbox = _wplwl_get_email_params.gdpr;
    let slice_text_color = _wplwl_get_email_params.slice_text_color;
    let wplwl_spinning_time = _wplwl_get_email_params.spinning_time;
    let wheel_speed = _wplwl_get_email_params.wheel_speed;
    let slices = piece_coupons.length;
    let sliceDeg = 360 / slices;
    let deg = -(sliceDeg / 2);
    let cv = document.getElementById('wplwl_canvas');
    let ctx = cv.getContext('2d');

    let canvas_width;
    let wd_width, wd_height;
    wd_width = window.innerWidth;
    wd_height = window.innerHeight;
    if (wd_width > wd_height) {
        canvas_width = wd_height;
    } else {
        canvas_width = wd_width;
    }
    let width = parseInt(wheel_size * (canvas_width * 0.55 + 16) / 100);// size
    cv.width = width;
    cv.height = width;
    if (window.devicePixelRatio) {
        let hidefCanvasWidth = $(cv).attr('width');
        let hidefCanvasHeight = $(cv).attr('height');
        let hidefCanvasCssWidth = hidefCanvasWidth;
        let hidefCanvasCssHeight = hidefCanvasHeight;

        $(cv).attr('width', hidefCanvasWidth * window.devicePixelRatio);
        $(cv).attr('height', hidefCanvasHeight * window.devicePixelRatio);
        $(cv).css('width', hidefCanvasCssWidth);
        $(cv).css('height', hidefCanvasCssHeight);
        ctx.scale(window.devicePixelRatio, window.devicePixelRatio);
    }

    let center = (width) / 2; // center
    $('.wplwl_wheel_spin').css({'width': width + 'px', 'height': width + 'px'});
    if ('on' === _wplwl_get_email_params.show_full_wheel) {
        $('.wplwl_lucky_wheel_content').css({'max-width': (width + 600) + 'px'});
    } else {
        $('.wplwl_lucky_wheel_content').css({'max-width': (0.6 * width + 600) + 'px'});
    }
    let inline_css = '.wplwl_lucky_wheel_content:not(.wplwl_lucky_wheel_content_mobile) .wheel-content-wrapper .wheel_content_left{min-width:' + (width + 35) + 'px}';
    if (_wplwl_get_email_params.pointer_position == 'center') {
        inline_css += '.wplwl_pointer:before{font-size:' + parseInt(width / 4) + 'px !important; }';
    } else {
        inline_css += '.wplwl_pointer:before{font-size:' + parseInt(width / 10) + 'px !important; }';
        inline_css += '.wplwl_margin_position .wplwl_wheel_spin_container .wplwl_pointer_content .wplwl_pointer:after{width:' + parseInt(width / 25) + 'px;height:' + parseInt(width / 25) + 'px;bottom:' + parseInt(width / 30) + 'px; }';
    }
    $('head').append('<style id="123123" type="text/css">' + inline_css + '</style>');
    inline_css = $('#wordpress-lucky-wheel-frontend-style-inline-css').html();
    $('#wordpress-lucky-wheel-frontend-style-inline-css').html(inline_css);
    let wheel_text_size;
    wheel_text_size = parseInt(width / 28) * parseInt(font_size) / 100;

    function deg2rad(deg) {
        return deg * Math.PI / 180;
    }

    function drawSlice(deg, color) {
        ctx.beginPath();
        ctx.fillStyle = color;
        ctx.moveTo(center, center);
        let r;
        if (width <= 480) {
            r = width / 2 - 10;
        } else {
            r = width / 2 - 14;
        }
        ctx.arc(center, center, r, deg2rad(deg), deg2rad(deg + sliceDeg));
        ctx.lineTo(center, center);
        ctx.fill();
    }

    function drawPoint(deg, color) {
        ctx.save();
        ctx.beginPath();
        ctx.fillStyle = color;
        ctx.shadowBlur = 1;
        ctx.shadowOffsetX = 8;
        ctx.shadowOffsetY = 8;
        ctx.shadowColor = 'rgba(0,0,0,0.2)';
        ctx.arc(center, center, width / 8, 0, 2 * Math.PI);
        ctx.fill();

        ctx.clip();
        ctx.restore();
    }

    function drawBorder(borderC, dotC, lineW, dotR, des, shadColor) {
        ctx.beginPath();
        ctx.strokeStyle = borderC;
        ctx.lineWidth = lineW;
        ctx.shadowBlur = 1;
        ctx.shadowOffsetX = 8;
        ctx.shadowOffsetY = 8;
        ctx.shadowColor = shadColor;
        ctx.arc(center, center, center, 0, 2 * Math.PI);
        ctx.stroke();
        let x_val, y_val, deg;
        deg = sliceDeg / 2;
        let center1 = center - des;
        for (let i = 0; i < slices; i++) {
            ctx.beginPath();
            ctx.fillStyle = dotC;
            x_val = center + center1 * Math.cos(deg * Math.PI / 180);
            y_val = center - center1 * Math.sin(deg * Math.PI / 180);
            ctx.arc(x_val, y_val, dotR, 0, 2 * Math.PI);
            ctx.fill();
            deg += sliceDeg;
        }
    }

    function drawText(deg, text, color) {
        let font_text_wheel = 'Helvetica';
        if (typeof _wplwl_get_email_params.font_text_wheel !== 'undefined' && _wplwl_get_email_params.font_text_wheel !== '') {
            font_text_wheel = _wplwl_get_email_params.font_text_wheel;
        }
        ctx.save();
        ctx.translate(center, center);
        ctx.rotate(deg2rad(deg));
        ctx.textAlign = "right";
        ctx.fillStyle = color;
        ctx.font = '200 ' + wheel_text_size + 'px ' + font_text_wheel;
        ctx.shadowOffsetX = 0;
        ctx.shadowOffsetY = 0;
        text = text.replace(/&#(\d{1,4});/g, function (fullStr, code) {
            return String.fromCharCode(code);
        });
        text = text.replace(/&nbsp;/g, ' ');
        let reText = text.split('\/n'), text1 = '', text2 = '';
        if (reText.length > 1) {
            text1 = reText[0];
            text2 = reText.splice(1, reText.length - 1);
            text2 = text2.join('');
        } else {
            reText = text.split('\\n');
            if (reText.length > 1) {
                text1 = reText[0];
                text2 = reText.splice(1, reText.length - 1);
                text2 = text2.join('');
            }
        }
        if (text1.trim() !== "" && text2.trim() !== "") {
            ctx.fillText(text1.trim(), 7 * center / 8, -(wheel_text_size * 1 / 4));
            ctx.fillText(text2.trim(), 7 * center / 8, wheel_text_size * 3 / 4);
        } else {
            ctx.fillText(text.replace(/\\n/g, '').replace(/\/n/g, ''), 7 * center / 8, wheel_text_size / 2 - 2);
        }
        ctx.restore();
    }

    function wplwl_trim(x) {
        return x.replace(/^\s+|\s+$/gm, '');
    }

//cookie
    function setCookie(cname, cvalue, expire) {
        let d = new Date();
        d.setTime(d.getTime() + (expire * 1000));
        let expires = "expires=" + d.toUTCString();
        document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
    }

    function getCookie(cname) {
        let name = cname + "=";
        let decodedCookie = decodeURIComponent(document.cookie);
        let ca = decodedCookie.split(';');
        for (let i = 0; i < ca.length; i++) {
            let c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
            }
            if (c.indexOf(name) == 0) {
                return c.substring(name.length, c.length);
            }
        }
        return "";
    }

    function overlay_function() {
        $('.wplwl-overlay').on('click', function () {
            $('html').removeClass('wplwl-html');
            $(this).hide();
            $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
            // let wplwl_delay = setTimeout(function () {
            //     $('.wplwl_lucky_wheel_content').hide();
            // }, 1000);
            // clearTimeout(wplwl_delay);
            setCookie('wplwl_cookie', 'closed', time_if_close);
            if (wplwl_hide_popup != 'on') {
                $('.wplwl_wheel_icon').addClass('wplwl_show');
            }
        });
    }

    function spins_wheel(stop_position, result_notification, result) {
        let canvas_1 = $('#wplwl_canvas');
        let canvas_3 = $('#wplwl_canvas2');
        let default_css = '';
        if (window.devicePixelRatio) {
            default_css = 'width:' + width + 'px;height:' + width + 'px;';
        }
        canvas_1.attr('style', default_css);
        canvas_3.attr('style', default_css);
        let stop_deg = 360 - sliceDeg * stop_position;
        let wheel_stop = wheel_speed * 360 * wplwl_spinning_time + stop_deg;
        let css = default_css + '-moz-transform: rotate(' + wheel_stop + 'deg);-webkit-transform: rotate(' + wheel_stop + 'deg);-o-transform: rotate(' + wheel_stop + 'deg);-ms-transform: rotate(' + wheel_stop + 'deg);transform: rotate(' + wheel_stop + 'deg);';
        css += '-webkit-transition: transform ' + wplwl_spinning_time + 's ease;-moz-transition: transform ' + wplwl_spinning_time + 's ease;-ms-transition: transform ' + wplwl_spinning_time + 's ease;-o-transition: transform ' + wplwl_spinning_time + 's ease;transition: transform ' + wplwl_spinning_time + 's ease;';
        canvas_1.attr('style', css);
        canvas_3.attr('style', css);
        setTimeout(function () {
            css = default_css + 'transform: rotate(' + stop_deg + 'deg);';
            canvas_1.attr('style', css);
            canvas_3.attr('style', css);

            $('.wplwl_lucky_wheel_content').addClass('wplwl-finish-spinning');
            $('.wplwl-overlay').unbind();
            $('.wplwl-overlay').on('click', function () {
                $('html').removeClass('wplwl-html');
                $(this).hide();

                $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
                $('.wplwl_wheel_spin').css({'margin-left': '0', 'transition': '2s'});
            });
            if (result === 'win' && congratulations_effect === 'firework') {
                $('.wplwl-congratulations-effect').addClass('wplwl-congratulations-effect-firework');
            }
            $('.wplwl_user_lucky').html('<div class="wplwl-frontend-result">' + result_notification + '</div>');
            $('.wplwl_user_lucky').fadeIn(300);
            if (wplwl_auto_close > 0) {
                setTimeout(function () {
                    $('.wplwl-overlay').hide();
                    $('html').removeClass('wplwl-html');
                    $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
                    $('.wplwl_wheel_spin').css({'margin-left': '0', 'transition': '2s'});
                }, wplwl_auto_close * 1000);
            }
        }, parseInt(wplwl_spinning_time * 1000))
    }

    function isValidEmailAddress(emailAddress) {
        let pattern = /^[a-zA-Z0-9._-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,6}$/i;
        return pattern.test(emailAddress);
    }

    function validateRecaptcha(response) {
        if (response) {
            jQuery('.wplwl-recaptcha-field #wplwl-g-validate-response').val(response);
        }
    }

    function expireRecaptcha() {
        jQuery('.wplwl-recaptcha-field #wplwl-g-validate-response').val(null);
        /*   if (_wplwl_get_email_params.wplwl_layout == 3) {
               let old_width = jQuery('.wplwl-recaptcha > div').width();
               let parent_width = jQuery('.wplwl-recaptcha').width();
               jQuery('.wplwl-recaptcha > div').css({transform: 'scale(' + parent_width / old_width + ',1)'});
           }*/
    }

    /* Googele recaptcha */
    window.addEventListener('load', function () {
        if (_wplwl_get_email_params.wplwl_recaptcha == 'on') {
            if (_wplwl_get_email_params.wplwl_recaptcha_version == 2) {
                wplwlreCaptchaV2Onload();
            } else {
                wplwlreCaptchaV3Onload();
                jQuery('.wplwl-recaptcha-field').hide();
            }
        } else {
            jQuery('.wplwl-recaptcha-field').hide();
        }
    });

    function wplwlreCaptchaV3Onload() {
        grecaptcha.ready(function () {
            grecaptcha.execute(_wplwl_get_email_params.wplwl_recaptcha_site_key, {action: 'homepage'}).then(function (token) {
                validateRecaptcha(token);
            })
        });
    }

    function wplwlreCaptchaV2Onload() {
        if (jQuery.find('.wplwl-recaptcha').length == 0 || jQuery.find('.wplwl-recaptcha iframe').length) {
            return true;
        }
        grecaptcha.render('wplwl-recaptcha', {
            'sitekey': _wplwl_get_email_params.wplwl_recaptcha_site_key,
            'callback': validateRecaptcha,
            'expired-callback': expireRecaptcha,
            'theme': _wplwl_get_email_params.wplwl_recaptcha_secret_theme,
            'isolated': false
        });
    }

    function check_email() {
        $(document).on('keypress', function (e) {
            if ($('.wplwl_lucky_wheel_content').hasClass('lucky_wheel_content_show') && e.keyCode === 13) {
                $('#wplwl_chek_mail').click();
            }
        });
        /*reCaptcha*/
        $('.wheel-content-wrapper').on('renderReCaptcha', function () {
            if (_wplwl_get_email_params.wplwl_recaptcha == 'on') {
                if (_wplwl_get_email_params.wplwl_recaptcha_version == 2) {
                    wplwlreCaptchaV2Onload();
                } else {
                    wplwlreCaptchaV3Onload();
                    $('.wheel-content-wrapper').find('.wplwl-recaptcha-field').hide();
                }
            }
        });

        window.addEventListener('load', function () {
            if (_wplwl_get_email_params.wplwl_recaptcha == 'on') {
                if (_wplwl_get_email_params.wplwl_recaptcha_version == 2) {
                    wplwlreCaptchaV2Onload();
                } else {
                    wplwlreCaptchaV3Onload();
                    $('.wheel-content-wrapper').find('.wplwl-recaptcha-field').hide();
                }
            }
        });
        $('#wplwl_chek_mail').on('click', function () {
            $('#wplwl_error_mail').html('');
            $('#wplwl_error_name').html('');
            $('#wplwl_error_mobile').html('');
            $('#wplwl_warring_recaptcha').html('');
            $('.wplwl_field_name').removeClass('wplwl-required-field');
            $('.wplwl_field_mobile').removeClass('wplwl-required-field');
            $('.wplwl_field_email').removeClass('wplwl-required-field');
            $('.wplwl-recaptcha-field').removeClass('wplwl-required-field');
            if ('on' === gdpr_checkbox && !$('.wplwl-gdpr-checkbox-wrap input[type="checkbox"]').prop('checked')) {
                alert(_wplwl_get_email_params.gdpr_warning);
                return false;
            }
            let wplwl_email = $('#wplwl_player_mail').val();
            let wplwl_name = $('#wplwl_player_name').val();
            let wplwl_mobile = $('#wplwl_player_mobile').val();
            let g_validate_response = $('#wplwl-g-validate-response').val();
            let qualified = true;
            if (_wplwl_get_email_params.wplwl_recaptcha && _wplwl_get_email_params.wplwl_recaptcha_site_key && !g_validate_response) {
                $('.wplwl-recaptcha-field #wplwl-recaptcha > div').addClass('wplwl-required-field').focus();
                $('#wplwl_warring_recaptcha').html(_wplwl_get_email_params.wplwl_warring_recaptcha);
                qualified = false;
            } else if (_wplwl_get_email_params.wplwl_recaptcha && _wplwl_get_email_params.wplwl_recaptcha_site_key) {
                $('.wplwl-recaptcha-field #wplwl-recaptcha > div').removeClass('wplwl-required-field');
                qualified = true;
            }

            if (custom_field_name_enable == 'on' && custom_field_name_required == 'on' && !wplwl_name) {
                $('#wplwl_error_name').html(_wplwl_get_email_params.custom_field_name_message);
                $('.wplwl_field_name').addClass('wplwl-required-field');
                qualified = false;
            }

            if (custom_field_mobile_enable == 'on' && custom_field_mobile_required == 'on' && !wplwl_mobile) {
                $('#wplwl_error_mobile').html(_wplwl_get_email_params.custom_field_mobile_message);
                $('.wplwl_field_mobile').addClass('wplwl-required-field');
                qualified = false;
            }
            /*
            * Check email when hook wplwl_skip_enter_email = false
            * */
            if (!wplwl_skip_enter_email) {
                if (!wplwl_email ) {
                    $('#wplwl_player_mail').prop('disabled', false).focus();
                    $('#wplwl_error_mail').html(_wplwl_get_email_params.empty_email_warning);
                    $('.wplwl_field_email').addClass('wplwl-required-field');
                    qualified = false;
                }
            }else{
                wplwl_email ='email';
            }

            if (qualified === false) {
                return false;
            }
            $(this).unbind();
            $('.wplwl-overlay').unbind();
            $('#wplwl_player_mail').prop('disabled', true);
            if (getCookie('wplwl_cookie') === "" || getCookie('wplwl_cookie') === 'closed') {
                if (isValidEmailAddress($('#wplwl_player_mail').val()) || wplwl_skip_enter_email) {
                    $('#wplwl_error_mail').html('');
                    $('#wplwl_chek_mail').addClass('wplwl-adding');

                    $.ajax({
                        type: 'post',
                        dataType: 'json',
                        url: _wplwl_get_email_params.ajaxurl,
                        data: {
                            user_email: wplwl_email,
                            user_name: wplwl_name,
                            user_mobile: wplwl_mobile,
                            language: _wplwl_get_email_params.language,
                            g_validate_response: g_validate_response,
                            _wordpress_lucky_wheel_nonce: $('#_wordpress_lucky_wheel_nonce').val(),
                        },
                        success: function (response) {
                            if (response.allow_spin === 'yes') {
                                $('.wplwl-show-again-option').hide();
                                $('.wplwl-close-wheel').hide();
                                $('.wplwl-hide-after-spin').show();
                                spins_wheel(response.stop_position, response.result_notification, response.result);

                                setCookie('wplwl_cookie', wplwl_email, wplwl_show_again);
                            } else {
                                $('#wplwl_chek_mail').removeClass('wplwl-adding');
                                $('#wplwl_player_mail').prop('disabled', false);
                                check_email();
                                overlay_function();
                                if (response.g_validate_response) {
                                    alert(response.warning);
                                } else {
                                    alert(response.allow_spin);
                                }
                            }
                            if (response.hasOwnProperty('metrilo_response')) {
                                let metrilo_response = response.metrilo_response;
                                if (metrilo_response.status === 'success' && window.hasOwnProperty('metrilo')) {
                                    if (window.metrilo.hasOwnProperty('customEvent') && typeof window.metrilo.customEvent === 'function') {
                                        window.metrilo.customEvent('wordpress_lucky_wheel');
                                    }
                                }
                            }
                        }
                    });

                } else {
                    $('#wplwl_player_mail').prop('disabled', false).focus();
                    check_email();
                    overlay_function();
                    $('#wplwl_error_mail').html(_wplwl_get_email_params.invalid_email_warning);
                    $('.wplwl_field_email').addClass('wplwl-required-field');
                }

            } else {
                alert(_wplwl_get_email_params.limit_time_warning);
                $('#wplwl_player_mail').prop('disabled', false);
                check_email();
                overlay_function();
            }
        });
    }

    function wplwl_rand(min, max) {
        if (max > min) {
            return Math.floor(Math.random() * (max - min + 1)) + min;
        } else {
            return Math.floor(Math.random() * (min - max + 1)) + max;
        }
    }

    overlay_function();
    check_email();
    let center1 = 32;

    if (!getCookie('wplwl_cookie') || getCookie('wplwl_cookie') == "") {
        $('.wplwl-hide-after-spin').bind('click', function () {
            $('.wplwl-overlay').hide();
            $('html').removeClass('wplwl-html');
            $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
            $('.wplwl_wheel_spin').css({'margin-left': '0', 'transition': '2s'});
            // setTimeout(function () {
            //     $('.wplwl_lucky_wheel_content').hide();
            // }, 2000);
        });

        $('.wplwl-reminder-later-a').unbind();
        $('.wplwl-reminder-later-a').bind('click', function () {
            setCookie('wplwl_cookie', 'reminder_later', 24 * 60 * 60);

            $('.wplwl_wheel_icon').addClass('wplwl_show');

            $('.wplwl-overlay').hide();
            $('html').removeClass('wplwl-html');
            $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
            // let wplwl_delay = setTimeout(function () {
            //     $('.wplwl_lucky_wheel_content').hide();
            // }, 1000);
            // clearTimeout(wplwl_delay);
        });
        $('.wplwl-never-again span').unbind();
        $('.wplwl-never-again span').bind('click', function () {
            setCookie('wplwl_cookie', 'never_show_again', 30 * 24 * 60 * 60);

            $('.wplwl_wheel_icon').addClass('wplwl_show');

            $('.wplwl-overlay').hide();
            $('html').removeClass('wplwl-html');
            $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
            // let wplwl_delay = setTimeout(function () {
            //     $('.wplwl_lucky_wheel_content').hide();
            // }, 1000);
            // clearTimeout(wplwl_delay);
        });
        $('.wplwl-close span').on('click', function () {
            $('.wplwl-overlay').hide();
            setCookie('wplwl_cookie', 'closed', time_if_close);
            $('html').removeClass('wplwl-html');
            $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
            if (wplwl_hide_popup != 'on') {
                $('.wplwl_wheel_icon').addClass('wplwl_show');
            }
        });
        $('.wplwl-close-wheel span').on('click', function () {
            $('.wplwl-overlay').hide();
            $('html').removeClass('wplwl-html');
            $('.wplwl_lucky_wheel_content').removeClass('lucky_wheel_content_show');
            // let wplwl_delay = setTimeout(function () {
            //     $('.wplwl_lucky_wheel_content').hide();
            // }, 1000);
            // clearTimeout(wplwl_delay);
            setCookie('wplwl_cookie', 'closed', time_if_close);
            if (wplwl_hide_popup != 'on') {
                $('.wplwl_wheel_icon').addClass('wplwl_show');
            }
        });


        $('.wordpress-lucky-wheel-popup-icon').on('click', function () {
            $('.wplwl_wheel_icon').removeClass('wplwl_show');
            $('.wplwl-overlay').show();
            $('html').addClass('wplwl-html');
            $('.wplwl_lucky_wheel_content').addClass('lucky_wheel_content_show');
        });

        for (let i = 0; i < slices; i++) {
            drawSlice(deg, color[i]);
            drawText(deg + sliceDeg / 2, label[i], slices_text_color[i]);
            deg += sliceDeg;

        }
        cv = document.getElementById('wplwl_canvas1');
        ctx = cv.getContext('2d');
        cv.width = width;
        cv.height = width;
        if (window.devicePixelRatio) {
            let hidefCanvasWidth = $(cv).attr('width');
            let hidefCanvasHeight = $(cv).attr('height');
            let hidefCanvasCssWidth = hidefCanvasWidth;
            let hidefCanvasCssHeight = hidefCanvasHeight;

            $(cv).attr('width', hidefCanvasWidth * window.devicePixelRatio);
            $(cv).attr('height', hidefCanvasHeight * window.devicePixelRatio);
            $(cv).css('width', hidefCanvasCssWidth);
            $(cv).css('height', hidefCanvasCssHeight);
            ctx.scale(window.devicePixelRatio, window.devicePixelRatio);
        }
        drawPoint(deg, wplwl_center_color);
        if ($('#wplwl_center_image').val()) {
            let wl_image = new Image;
            wl_image.onload = function () {
                cv = document.getElementById('wplwl_canvas1');
                ctx = cv.getContext('2d');
                let image_size = 2 * (width / 8 - 7);
                ctx.arc(center, center, image_size / 2, 0, 2 * Math.PI);
                ctx.clip();
                ctx.drawImage(wl_image, center - image_size / 2, center - image_size / 2, image_size, image_size);

            };
            wl_image.src = $('#wplwl_center_image').val();
        }

        if (width <= 480) {
            drawBorder(wplwl_border_color, 'rgba(0,0,0,0)', 20, 4, 5, 'rgba(0,0,0,0.2)');

        } else {
            drawBorder(wplwl_border_color, 'rgba(0,0,0,0)', 30, 6, 7, 'rgba(0,0,0,0.2)');
        }

        cv = document.getElementById('wplwl_canvas2');
        ctx = cv.getContext('2d');

        cv.width = width;
        cv.height = width;
        if (window.devicePixelRatio) {
            let hidefCanvasWidth = $(cv).attr('width');
            let hidefCanvasHeight = $(cv).attr('height');
            let hidefCanvasCssWidth = hidefCanvasWidth;
            let hidefCanvasCssHeight = hidefCanvasHeight;

            $(cv).attr('width', hidefCanvasWidth * window.devicePixelRatio);
            $(cv).attr('height', hidefCanvasHeight * window.devicePixelRatio);
            $(cv).css('width', hidefCanvasCssWidth);
            $(cv).css('height', hidefCanvasCssHeight);
            ctx.scale(window.devicePixelRatio, window.devicePixelRatio);
        }
        if (width <= 480) {
            drawBorder('rgba(0,0,0,0)', wplwl_dot_color, 20, 4, 5, 'rgba(0,0,0,0)');

        } else {
            drawBorder('rgba(0,0,0,0)', wplwl_dot_color, 30, 6, 7, 'rgba(0,0,0,0)');
        }

        if (intent_type === 'popup_icon') {
            let notify_time_out = setTimeout(function () {
                $('.wplwl_wheel_icon').addClass('wplwl_show');

            }, initial_time * 1000);
        } else if (intent_type === 'show_wheel') {
            setTimeout(function () {
                $('.wplwl-overlay').show();
                $('html').addClass('wplwl-html');
                $('.wplwl_lucky_wheel_content').addClass('lucky_wheel_content_show');
            }, initial_time * 1000);
        } else if (intent_type === 'on_scroll') {
            let htmlHeight, scrollHeight, scrollTop, scrollRate;
            $(document).on('scroll', function () {
                if (!getCookie('wplwl_cookie')) {
                    htmlHeight = $('html').prop('scrollHeight');
                    scrollHeight = window.innerHeight;
                    scrollTop = $('html').prop('scrollTop');
                    if (htmlHeight > 0) {
                        scrollRate = (scrollTop + scrollHeight) * 100 / (htmlHeight);
                        if (scrollRate > scroll_amount) {
                            $('.wplwl-overlay').show();
                            $('html').addClass('wplwl-html');
                            $('.wplwl_lucky_wheel_content').addClass('lucky_wheel_content_show');
                        }
                    }
                }
            });
        } else if (intent_type === 'on_exit') {
            $(window).on('mousemove', function (event) {
                let scrollTop = $('html').prop('scrollTop');
                let pageY = event.pageY;
                if (!getCookie('wplwl_cookie')) {
                    if (pageY - scrollTop < 15) {
                        $('.wplwl-overlay').show();
                        $('html').addClass('wplwl-html');
                        $('.wplwl_lucky_wheel_content').addClass('lucky_wheel_content_show');
                    }
                }
            })
        }

    }

    function drawPopupIcon() {
        cv = document.getElementById('wplwl_popup_canvas');
        if (cv) {
            ctx = cv.getContext('2d');

            for (let k = 0; k < slices; k++) {
                drawSlice1(deg, color[k]);
                deg += sliceDeg;
            }
            drawPoint1(wplwl_center_color);
            drawBorder1(wplwl_border_color, wplwl_dot_color, 4, 1, 0);
        }
    }

    drawPopupIcon();

    function drawSlice1(deg, color) {
        ctx.beginPath();
        ctx.fillStyle = color;
        ctx.moveTo(center1, center1);
        ctx.arc(center1, center1, 32, deg2rad(deg), deg2rad(deg + sliceDeg));
        ctx.lineTo(center1, center1);
        ctx.fill();
    }

    function drawPoint1(color) {
        ctx.save();
        ctx.beginPath();
        ctx.fillStyle = color;
        ctx.arc(center1, center1, 8, 0, 2 * Math.PI);
        ctx.fill();
        ctx.restore();
    }

    function drawBorder1(borderC, dotC, lineW, dotR, des) {
        ctx.beginPath();
        ctx.strokeStyle = borderC;
        ctx.lineWidth = lineW;
        ctx.arc(center1, center1, center1, 0, 2 * Math.PI);
        ctx.stroke();
        let x_val, y_val, deg;
        deg = sliceDeg / 2;
        let center2 = center1 - des;
        for (let i = 0; i < slices; i++) {
            ctx.beginPath();
            ctx.fillStyle = dotC;
            x_val = center1 + center2 * Math.cos(deg * Math.PI / 180);
            y_val = center1 - center2 * Math.sin(deg * Math.PI / 180);
            ctx.arc(x_val, y_val, dotR, 0, 2 * Math.PI);
            ctx.fill();
            deg += sliceDeg;
        }
    }

    /*falling leaves effect*/
    let wplwlLeafScene = function (el) {
        this.viewport = el;
        this.world = document.createElement('div');
        this.leaves = [];

        this.options = {
            numLeaves: 30,
            wind: {
                magnitude: 1.2,
                maxSpeed: 3,
                duration: 500,
                start: 0,
                speed: 0
            }
        };

        this.width = this.viewport.offsetWidth;
        this.height = this.viewport.offsetHeight;

        // animation helper
        this.timer = 0;

        this._resetLeaf = function (leaf) {

            // place leaf towards the top left
            leaf.x = this.width * 2 - Math.random() * this.width * 1.75;
            leaf.y = -10;
            leaf.z = Math.random() * 200;
            if (leaf.x > this.width) {
                leaf.x = this.width + 10;
                leaf.y = Math.random() * this.height / 2;
            }
            // at the start, the leaf can be anywhere
            if (this.timer == 0) {
                leaf.y = Math.random() * this.height;
            }

            // Choose axis of rotation.
            // If axis is not X, chose a random static x-rotation for greater letiability
            leaf.rotation.speed = Math.random() * 10;
            let randomAxis = Math.random();
            if (randomAxis > 0.5) {
                leaf.rotation.axis = 'X';
            } else if (randomAxis > 0.25) {
                leaf.rotation.axis = 'Y';
                leaf.rotation.x = Math.random() * 180 + 90;
            } else {
                leaf.rotation.axis = 'Z';
                leaf.rotation.x = Math.random() * 360 - 180;
                // looks weird if the rotation is too fast around this axis
                leaf.rotation.speed = Math.random() * 3;
            }

            // random speed
            leaf.xSpeedVariation = Math.random() * 0.8 - 0.4;
            leaf.ySpeed = Math.random() + 1.5;

            return leaf;
        }

        this._updateLeaf = function (leaf) {
            let leafWindSpeed = this.options.wind.speed(this.timer - this.options.wind.start, leaf.y);

            let xSpeed = leafWindSpeed + leaf.xSpeedVariation;
            leaf.x -= xSpeed;
            leaf.y += leaf.ySpeed;
            leaf.rotation.value += leaf.rotation.speed;

            let t = 'translateX( ' + leaf.x + 'px ) translateY( ' + leaf.y + 'px ) translateZ( ' + leaf.z + 'px ) ';
            if (_wplwl_get_email_params.rotate) {
                t += ' rotate' + leaf.rotation.axis + '( ' + leaf.rotation.value + 'deg )';
                if (leaf.rotation.axis !== 'X') {
                    t += ' rotateX(' + leaf.rotation.x + 'deg)';
                }
            }
            leaf.el.style.webkitTransform = t;
            leaf.el.style.MozTransform = t;
            leaf.el.style.oTransform = t;
            leaf.el.style.transform = t;

            // reset if out of view
            if (leaf.x < -10 || leaf.y > this.height + 10) {
                this._resetLeaf(leaf);
            }
        }

        this._updateWind = function () {
            // wind follows a sine curve: asin(b*time + c) + a
            // where a = wind magnitude as a function of leaf position, b = wind.duration, c = offset
            // wind duration should be related to wind magnitude, e.g. higher windspeed means longer gust duration

            if (this.timer === 0 || this.timer > (this.options.wind.start + this.options.wind.duration)) {

                this.options.wind.magnitude = Math.random() * this.options.wind.maxSpeed;
                this.options.wind.duration = this.options.wind.magnitude * 50 + (Math.random() * 20 - 10);
                this.options.wind.start = this.timer;

                let screenHeight = this.height;

                this.options.wind.speed = function (t, y) {
                    // should go from full wind speed at the top, to 1/2 speed at the bottom, using leaf Y
                    let a = this.magnitude / 2 * (screenHeight - 2 * y / 3) / screenHeight;
                    return a * Math.sin(2 * Math.PI / this.duration * t + (3 * Math.PI / 2)) + a;
                }
            }
        }
    };

    wplwlLeafScene.prototype.init = function () {

        for (let i = 0; i < this.options.numLeaves; i++) {
            let leaf = {
                el: document.createElement('div'),
                x: 0,
                y: 0,
                z: 0,
                rotation: {
                    axis: 'X',
                    value: 0,
                    speed: 0,
                    x: 0
                },
                xSpeedVariation: 0,
                ySpeed: 0,
                path: {
                    type: 1,
                    start: 0,

                },
                image: 1
            };
            this._resetLeaf(leaf);
            this.leaves.push(leaf);
            this.world.appendChild(leaf.el);
        }

        this.world.className = 'wplwl-leaf-scene';
        this.viewport.appendChild(this.world);

        // set perspective
        this.world.style.webkitPerspective = "400px";
        this.world.style.MozPerspective = "400px";
        this.world.style.oPerspective = "400px";
        this.world.style.perspective = "400px";

        // reset window height/width on resize
        let self = this;
        window.onresize = function (event) {
            self.width = self.viewport.offsetWidth;
            self.height = self.viewport.offsetHeight;
        };
    };

    wplwlLeafScene.prototype.render = function () {
        this._updateWind();
        for (let i = 0; i < this.leaves.length; i++) {
            this._updateLeaf(this.leaves[i]);
        }

        this.timer++;

        requestAnimationFrame(this.render.bind(this));
    };
    if ($('.wplwl_lucky_wheel_content').hasClass('wplwl-background-effect-falling-leaves')) {
        let leafContainer = document.querySelector('.wplwl_lucky_wheel_content');
        let leaves = new wplwlLeafScene(leafContainer);
        leaves.init();
        leaves.render();
    }
});
